import { XButtonGroup } from "./XButtonGroup";
import { IgcXButtonComponent } from './igc-x-button-component';
import { IgcXButtonGroupButtonCollection } from './igc-x-button-group-button-collection';
import { ButtonGroupOrientation } from './ButtonGroupOrientation';
import { IgcButtonGroupSelectionChangedEventArgs } from './igc-button-group-selection-changed-event-args';
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { ButtonGroupDisplayStyle } from './ButtonGroupDisplayStyle';
import { IgcHTMLElement } from "igniteui-webcomponents-core";
export declare class IgcXButtonGroupComponent extends IgcHTMLElement {
    private _portalManager;
    private _container;
    private _renderer;
    contentButtons: IgcXButtonComponent[];
    /**
    * The style mappings actually present in the treemap. Do not directly modify this array.
    * This array's contents can be modified by causing Angular to reproject the child content.
    * Or adding and removing style mappings from the manual style mappings collection on the buttons property.
    */
    actualButtons: IgcXButtonComponent[];
    private _buttons;
    private _buttonsAdapter;
    /**
     * A collection or manually added axes for the chart.
    */
    get buttons(): IgcXButtonGroupButtonCollection;
    constructor();
    private _onChildrenChanged;
    private updateButtons;
    updateStyle(): void;
    destroy(): void;
    private _wrapper;
    protected createImplementation(): XButtonGroup;
    private _buttonGroup;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): XButtonGroup; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcXButtonGroupComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcXButtonGroupComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets the display style to use for the button.
*/
    get displayType(): ButtonGroupDisplayStyle;
    set displayType(v: ButtonGroupDisplayStyle);
    /**
     * Gets or sets the base built in theme to use for the button group.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the display density to use for the button group.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets the actual display density to use for the button group.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    /**
     * Gets the currently selected button indices.
    */
    get selectedIndices(): number[];
    set selectedIndices(v: number[]);
    /**
     * Gets the actual item corner radius for the appropriate corners.
    */
    get actualItemCornerRadius(): number;
    set actualItemCornerRadius(v: number);
    /**
     * Gets the actual item background color.
    */
    get actualItemBackgroundColor(): string;
    set actualItemBackgroundColor(v: string);
    /**
     * Gets the actual item background color.
    */
    get actualItemDisabledBackgroundColor(): string;
    set actualItemDisabledBackgroundColor(v: string);
    /**
     * Gets the actual item text color.
    */
    get actualItemTextColor(): string;
    set actualItemTextColor(v: string);
    /**
     * Gets the actual item text color.
    */
    get actualItemDisabledTextColor(): string;
    set actualItemDisabledTextColor(v: string);
    /**
     * Gets the actual item border color.
    */
    get actualItemBorderColor(): string;
    set actualItemBorderColor(v: string);
    /**
     * Gets the actual item border color.
    */
    get actualItemDisabledBorderColor(): string;
    set actualItemDisabledBorderColor(v: string);
    /**
     * Gets the actual item border width.
    */
    get actualItemBorderWidth(): number;
    set actualItemBorderWidth(v: number);
    /**
     * Gets the actual selected item background color.
    */
    get actualSelectedItemBackgroundColor(): string;
    set actualSelectedItemBackgroundColor(v: string);
    /**
     * Gets the stroke actual selected item text color.
    */
    get actualSelectedItemTextColor(): string;
    set actualSelectedItemTextColor(v: string);
    /**
     * Gets the actual item hovered background color.
    */
    get actualItemHoverBackgroundColor(): string;
    set actualItemHoverBackgroundColor(v: string);
    /**
     * Gets the actual item text color.
    */
    get actualItemHoverTextColor(): string;
    set actualItemHoverTextColor(v: string);
    /**
     * Gets the actual selected item hovered background color.
    */
    get actualSelectedItemHoverBackgroundColor(): string;
    set actualSelectedItemHoverBackgroundColor(v: string);
    /**
     * Gets the actual selected item hovered text color.
    */
    get actualSelectedItemHoverTextColor(): string;
    set actualSelectedItemHoverTextColor(v: string);
    /**
     * Gets or sets the corner radius to use for the appropriate corners for the item buttons.
    */
    get itemCornerRadius(): number;
    set itemCornerRadius(v: number);
    /**
     * Gets or sets the color to use the background of the buttons in the group.
    */
    get itemBackgroundColor(): string;
    set itemBackgroundColor(v: string);
    /**
     * Gets or sets the disabled color to use the background of the buttons in the group.
    */
    get itemDisabledBackgroundColor(): string;
    set itemDisabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the text of the buttons in the group.
    */
    get itemTextColor(): string;
    set itemTextColor(v: string);
    /**
     * Gets or sets the disabled color to use the text of the buttons in the group.
    */
    get itemDisabledTextColor(): string;
    set itemDisabledTextColor(v: string);
    /**
     * Gets or sets the color to use the hovered background of the buttons in the group.
    */
    get itemHoverBackgroundColor(): string;
    set itemHoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the border of the buttons in the group.
    */
    get itemBorderColor(): string;
    set itemBorderColor(v: string);
    /**
     * Gets or sets the disabled color to use the border of the buttons in the group.
    */
    get itemDisabledBorderColor(): string;
    set itemDisabledBorderColor(v: string);
    /**
     * Gets or sets the border width to use for the buttons in the group.
    */
    get itemBorderWidth(): number;
    set itemBorderWidth(v: number);
    /**
     * Gets or sets the color to use the hovered text of the buttons in the group.
    */
    get itemHoverTextColor(): string;
    set itemHoverTextColor(v: string);
    /**
     * Gets or sets the color to use the background of the buttons in the group that are selected.
    */
    get selectedItemBackgroundColor(): string;
    set selectedItemBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the text of the buttons in the group that are selected.
    */
    get selectedItemTextColor(): string;
    set selectedItemTextColor(v: string);
    /**
     * Gets or sets the color to use the hovered background of the buttons in the group that are selected.
    */
    get selectedItemHoverBackgroundColor(): string;
    set selectedItemHoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the hovered text of the buttons in the group that are selected.
    */
    get selectedItemHoverTextColor(): string;
    set selectedItemHoverTextColor(v: string);
    /**
     * Gets or sets the corner radius to use for the appropriate corners for the outlined type item buttons.
    */
    get outlinedItemCornerRadius(): number;
    set outlinedItemCornerRadius(v: number);
    /**
     * Gets or sets the color to use the background of the buttons in the group when type is outlined.
    */
    get outlinedItemBackgroundColor(): string;
    set outlinedItemBackgroundColor(v: string);
    /**
     * Gets or sets the disabled color to use the background of the buttons in the group when type is outlined.
    */
    get outlinedItemDisabledBackgroundColor(): string;
    set outlinedItemDisabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the text of the buttons in the group when type is outlined.
    */
    get outlinedItemTextColor(): string;
    set outlinedItemTextColor(v: string);
    /**
     * Gets or sets the disabled color to use the text of the buttons in the group when type is outlined.
    */
    get outlinedItemDisabledTextColor(): string;
    set outlinedItemDisabledTextColor(v: string);
    /**
     * Gets or sets the color to use the hovered background of the buttons in the group when type is outlined.
    */
    get outlinedItemHoverBackgroundColor(): string;
    set outlinedItemHoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the border of the buttons in the group when type is outlined.
    */
    get outlinedItemBorderColor(): string;
    set outlinedItemBorderColor(v: string);
    /**
     * Gets or sets the disabled color to use the border of the buttons in the group when type is outlined.
    */
    get outlinedItemDisabledBorderColor(): string;
    set outlinedItemDisabledBorderColor(v: string);
    /**
     * Gets or sets the border width to use for the buttons in the group when type is outlined.
    */
    get outlinedItemBorderWidth(): number;
    set outlinedItemBorderWidth(v: number);
    /**
     * Gets or sets the color to use the hovered text of the buttons in the group when type is outlined.
    */
    get outlinedItemHoverTextColor(): string;
    set outlinedItemHoverTextColor(v: string);
    /**
     * Gets or sets the color to use the background of the buttons in the group that are selected when type is outlined.
    */
    get outlinedSelectedItemBackgroundColor(): string;
    set outlinedSelectedItemBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the text of the buttons in the group that are selected when type is outlined.
    */
    get outlinedSelectedItemTextColor(): string;
    set outlinedSelectedItemTextColor(v: string);
    /**
     * Gets or sets the color to use the hovered background of the buttons in the group that are selected when type is outlined.
    */
    get outlinedSelectedItemHoverBackgroundColor(): string;
    set outlinedSelectedItemHoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the hovered text of the buttons in the group that are selected when type is outlined.
    */
    get outlinedSelectedItemHoverTextColor(): string;
    set outlinedSelectedItemHoverTextColor(v: string);
    /**
     * Gets or sets the corner radius to use for the appropriate corners for the flat type item buttons.
    */
    get flatItemCornerRadius(): number;
    set flatItemCornerRadius(v: number);
    /**
     * Gets or sets the color to use the background of the buttons in the group when type is flat.
    */
    get flatItemBackgroundColor(): string;
    set flatItemBackgroundColor(v: string);
    /**
     * Gets or sets the disabled color to use the background of the buttons in the group when type is flat.
    */
    get flatItemDisabledBackgroundColor(): string;
    set flatItemDisabledBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the text of the buttons in the group when type is flat.
    */
    get flatItemTextColor(): string;
    set flatItemTextColor(v: string);
    /**
     * Gets or sets the disabled color to use the text of the buttons in the group when type is flat.
    */
    get flatItemDisabledTextColor(): string;
    set flatItemDisabledTextColor(v: string);
    /**
     * Gets or sets the color to use the hovered background of the buttons in the group when type is flat.
    */
    get flatItemHoverBackgroundColor(): string;
    set flatItemHoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the border of the buttons in the group when type is flat.
    */
    get flatItemBorderColor(): string;
    set flatItemBorderColor(v: string);
    /**
     * Gets or sets the disabled color to use the border of the buttons in the group when type is flat.
    */
    get flatItemDisabledBorderColor(): string;
    set flatItemDisabledBorderColor(v: string);
    /**
     * Gets or sets the border width to use for the buttons in the group when type is flat.
    */
    get flatItemBorderWidth(): number;
    set flatItemBorderWidth(v: number);
    /**
     * Gets or sets the color to use the hovered text of the buttons in the group when type is flat.
    */
    get flatItemHoverTextColor(): string;
    set flatItemHoverTextColor(v: string);
    /**
     * Gets or sets the color to use the background of the buttons in the group that are selected when type is flat.
    */
    get flatSelectedItemBackgroundColor(): string;
    set flatSelectedItemBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the text of the buttons in the group that are selected when type is flat.
    */
    get flatSelectedItemTextColor(): string;
    set flatSelectedItemTextColor(v: string);
    /**
     * Gets or sets the color to use the hovered background of the buttons in the group that are selected when type is flat.
    */
    get flatSelectedItemHoverBackgroundColor(): string;
    set flatSelectedItemHoverBackgroundColor(v: string);
    /**
     * Gets or sets the color to use the hovered text of the buttons in the group that are selected when type is flat.
    */
    get flatSelectedItemHoverTextColor(): string;
    set flatSelectedItemHoverTextColor(v: string);
    /**
     * Gets or sets the oreientation to use the button group when type is outlined.
    */
    get orientation(): ButtonGroupOrientation;
    set orientation(v: ButtonGroupOrientation);
    /**
     * Gets or sets the id to use for the button group.
    */
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    /**
     * Gets or sets whether the group supports multi-select.
    */
    get isMultiSelect(): boolean;
    set isMultiSelect(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _selectionChanged;
    private _selectionChanged_wrapped;
    get selectionChanged(): (s: IgcXButtonGroupComponent, e: IgcButtonGroupSelectionChangedEventArgs) => void;
    set selectionChanged(ev: (s: IgcXButtonGroupComponent, e: IgcButtonGroupSelectionChangedEventArgs) => void);
}
