import { XCalendar } from './XCalendar';
import { IgcSelectedValueChangedEventArgs } from "./igc-selected-value-changed-event-args";
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
export declare class IgcXCalendarComponent extends HTMLElement {
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _container;
    private _renderer;
    constructor();
    updateStyle(): void;
    destroy(): void;
    protected createImplementation(): XCalendar;
    private _calendar;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): XCalendar; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcXCalendarComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcXCalendarComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or Sets the value for the calendar.
*/
    get value(): Date;
    set value(v: Date);
    /**
     * Gets or Sets the property name that contains the values.
    */
    get today(): Date;
    set today(v: Date);
    /**
     * Gets or Sets the property name that contains the MinDate.
    */
    get minDate(): Date;
    set minDate(v: Date);
    /**
     * Gets or Sets the property name that contains the MaxDate.
    */
    get maxDate(): Date;
    set maxDate(v: Date);
    /**
     * Gets or sets the display density to use for the calendar.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets or sets the base built in theme to use for the calendar.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or Sets the selected date background color
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or Sets the selected date background color
    */
    get selectedDateBackgroundColor(): string;
    set selectedDateBackgroundColor(v: string);
    /**
     * Gets or Sets the selected date background color
    */
    get selectedFocusDateBackgroundColor(): string;
    set selectedFocusDateBackgroundColor(v: string);
    /**
     * Gets or Sets the focus date background color
    */
    get focusDateBackgroundColor(): string;
    set focusDateBackgroundColor(v: string);
    /**
     * Gets or Sets the focus date background color
    */
    get hoverBackgroundColor(): string;
    set hoverBackgroundColor(v: string);
    /**
     * Gets or Sets the selected date text color
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or Sets the selected date text color
    */
    get selectedDateTextColor(): string;
    set selectedDateTextColor(v: string);
    /**
     * Gets or Sets the focus date text color
    */
    get focusDateTextColor(): string;
    set focusDateTextColor(v: string);
    /**
     * Gets or Sets the current date text color
    */
    get currentDateTextColor(): string;
    set currentDateTextColor(v: string);
    /**
     * Gets or Sets the current date text color
    */
    get currentDateBorderColor(): string;
    set currentDateBorderColor(v: string);
    /**
     * Gets or sets the ShowTodayButton property to detirmine if the today button is shown
    */
    get showTodayButton(): boolean;
    set showTodayButton(v: boolean);
    /**
     * Gets or sets the font to use for the combobox.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the FirstDayOfWeek property to detirmine first day of the week
    */
    get firstDayOfWeek(): DayOfWeek;
    set firstDayOfWeek(v: DayOfWeek);
    /**
     * Gets or sets the FirstWeekOfYear property to detirmine first week of the year
    */
    get firstWeekOfYear(): FirstWeek;
    set firstWeekOfYear(v: FirstWeek);
    /**
     * Gets or sets the ShowWeekNumbers property to detirmine if the week numbers are shown
    */
    get showWeekNumbers(): boolean;
    set showWeekNumbers(v: boolean);
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Exports visual information about the current state of the grid.

*/
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _selectedValueChanged;
    private _selectedValueChanged_wrapped;
    /**
     * Called when date is selected.
    */
    get selectedValueChanged(): (s: IgcXCalendarComponent, e: IgcSelectedValueChangedEventArgs) => void;
    set selectedValueChanged(ev: (s: IgcXCalendarComponent, e: IgcSelectedValueChangedEventArgs) => void);
    private _valueChange;
    private _valueChange_wrapped;
    get valueChange(): (s: IgcXCalendarComponent, e: Date) => void;
    set valueChange(ev: (s: IgcXCalendarComponent, e: Date) => void);
}
