import { XCheckbox } from "./XCheckbox";
import { IgcCheckboxChangeEventArgs } from './igc-checkbox-change-event-args';
import { CheckboxLabelPosition } from './CheckboxLabelPosition';
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
export declare class IgcXCheckboxComponent extends IgcHTMLElement {
    private _portalManager;
    private _container;
    private _renderer;
    constructor();
    private _onChildrenChanged;
    updateStyle(): void;
    destroy(): void;
    private _wrapper;
    protected createImplementation(): XCheckbox;
    private _checkbox;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): XCheckbox; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcXCheckboxComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcXCheckboxComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets the base built in theme to use for the checkbox.
*/
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the color to use for the background when the checkbox is unchecked.
    */
    get uncheckedBackgroundColor(): string;
    set uncheckedBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the actual background when the checkbox is unchecked.
    */
    get actualUncheckedBackgroundColor(): string;
    set actualUncheckedBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the background when the checkbox is checked.
    */
    get checkedBackgroundColor(): string;
    set checkedBackgroundColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get tickColor(): string;
    set tickColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualTickColor(): string;
    set actualTickColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is unchecked.
    */
    get uncheckedBorderColor(): string;
    set uncheckedBorderColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get checkedBorderColor(): string;
    set checkedBorderColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualUncheckedBorderColor(): string;
    set actualUncheckedBorderColor(v: string);
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualCheckedBorderColor(): string;
    set actualCheckedBorderColor(v: string);
    /**
     * Gets or sets the Width to use for the check mark when the checkbox is checked.
    */
    get borderWidth(): number;
    set borderWidth(v: number);
    /**
     * Gets or sets the Width to use for the check mark when the checkbox is checked.
    */
    get actualBorderWidth(): number;
    set actualBorderWidth(v: number);
    /**
     * Gets or sets the corner radius to use for the checkbox.
    */
    get cornerRadius(): number;
    set cornerRadius(v: number);
    /**
     * Gets or sets the corner radius to use for the checkbox.
    */
    get tickStrokeWidth(): number;
    set tickStrokeWidth(v: number);
    /**
     * Gets or sets the stroke width to use for the check mark.
    */
    get actualTickStrokeWidth(): number;
    set actualTickStrokeWidth(v: number);
    /**
     * Gets the actual corner radius to use for the checkbox.
    */
    get actualCornerRadius(): number;
    set actualCornerRadius(v: number);
    /**
     * Gets or sets the color to use for the actual background when the checkbox is checked.
    */
    get actualCheckedBackgroundColor(): string;
    set actualCheckedBackgroundColor(v: string);
    /**
     * Gets or sets the id to use for the internal native checkbox.
    */
    get inputId(): string;
    set inputId(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets id to use for the checkbox label.
    */
    get labelId(): string;
    set labelId(v: string);
    /**
     * Gets or sets name to use for the checkbox.
    */
    get name(): string;
    set name(v: string);
    /**
     * Gets or sets TabIndex to use for the checkbox.
    */
    get tabIndex(): number;
    set tabIndex(v: number);
    /**
     * Gets or sets if the checkbox is required.
    */
    get required(): number;
    set required(v: number);
    /**
     * Gets or sets the value of the aria-labelledby attribute.
    */
    get ariaLabelledBy(): string;
    set ariaLabelledBy(v: string);
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    get ariaLabel(): string;
    set ariaLabel(v: string);
    /**
     * Gets or sets value to use for the checkbox.
    */
    get value(): any;
    set value(v: any);
    /**
     * Gets or sets if the checkbox is Focused.
    */
    get focused(): boolean;
    set focused(v: boolean);
    /**
     * Gets or sets LabelPosition to use for the checkbox.
    */
    get labelPosition(): CheckboxLabelPosition;
    set labelPosition(v: CheckboxLabelPosition);
    /**
     * Gets or sets whether to disable the ripple effect for the checkbox.
    */
    get disableRipple(): boolean;
    set disableRipple(v: boolean);
    /**
     * Gets or sets whether the checkbox is checked.
    */
    get checked(): boolean;
    set checked(v: boolean);
    /**
     * Gets or sets whether the checkbox is indeterminate.
    */
    get indeterminate(): boolean;
    set indeterminate(v: boolean);
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    /**
     * Gets or sets whether the checkbox transitions are disabled.
    */
    get disableTransitions(): boolean;
    set disableTransitions(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    private _change;
    private _change_wrapped;
    get change(): (s: IgcXCheckboxComponent, e: IgcCheckboxChangeEventArgs) => void;
    set change(ev: (s: IgcXCheckboxComponent, e: IgcCheckboxChangeEventArgs) => void);
}
