import { XInput } from "./XInput";
import { IgcXInputGroupItemComponent } from './igc-x-input-group-item-component';
import { IgcInputChangeEventArgs } from './igc-input-change-event-args';
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { IgcKeyEventArgs } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { HorizontalAlignment } from "igniteui-webcomponents-core";
export declare class IgcXInputComponent extends IgcXInputGroupItemComponent {
    private _portalManager;
    private _container;
    private _renderer;
    constructor();
    private _onChildrenChanged;
    updateStyle(): void;
    destroy(): void;
    private _wrapper;
    protected createImplementation(): XInput;
    private _input;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    /**
                             * @hidden
                             */
    get i(): XInput;
    private static _observedAttributesIgcXInputComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets the base built in theme to use for the button.
*/
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the display density to use for the input.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets the actual display density to use for the label.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    /**
     * Gets/Sets the input mask for the input.
    */
    get mask(): string;
    set mask(v: string);
    /**
     * Gets/Sets the character representing a fillable spot in the input mask
    */
    get promptChar(): string;
    set promptChar(v: string);
    /**
     * Specifies if the bound value includes the formatting symbols.
    */
    get includeLiterals(): boolean;
    set includeLiterals(v: boolean);
    get showSpinner(): boolean;
    set showSpinner(v: boolean);
    /**
     * Gets the actual color to use for the text color.
    */
    get actualTextColor(): string;
    set actualTextColor(v: string);
    /**
     * Gets the actual hover color to use for the text.
    */
    get actualHoverTextColor(): string;
    set actualHoverTextColor(v: string);
    /**
     * Gets or sets the color to use for the text.
    */
    get textColor(): string;
    set textColor(v: string);
    /**
     * Gets or sets the use for the button.
    */
    get textStyle(): string;
    set textStyle(v: string);
    /**
     * Gets or sets the type to use for the input.
    */
    get inputType(): string;
    set inputType(v: string);
    /**
     * Gets or sets the placeholder to use for the input.
    */
    get placeholder(): string;
    set placeholder(v: string);
    /**
     * Gets or sets the color to use for the hovered text of the button regardless of type.
    */
    get hoverTextColor(): string;
    set hoverTextColor(v: string);
    /**
     * Gets or sets the id to use for the checkbox.
    */
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets TabIndex to use for the checkbox.
    */
    get tabIndex(): number;
    set tabIndex(v: number);
    /**
     * Gets or sets the for attribute to use for the input.
    */
    get for(): string;
    set for(v: string);
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    get ariaLabel(): string;
    set ariaLabel(v: string);
    /**
     * Gets or sets whether the input is hovered.
    */
    get isHover(): boolean;
    set isHover(v: boolean);
    /**
     * Gets or sets the value for the input.
    */
    get value(): string;
    set value(v: string);
    get hasValue(): boolean;
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    /**
     * Gets or sets whether the checkbox is readonly.
    */
    get readonly(): boolean;
    set readonly(v: boolean);
    /**
     * Gets or sets the alignment of the text.
    */
    get textAlignment(): HorizontalAlignment;
    set textAlignment(v: HorizontalAlignment);
    /**
     * Returns / Sets the beginning index of the selected text. When nothing is selected, this returns the position of the text input cursor (caret) inside of the input.
    */
    get selectionStart(): number;
    set selectionStart(v: number);
    /**
     * Returns / Sets the end index of the selected text. When nothing is selected, this returns the position of the text input cursor (caret) inside of the input.
    */
    get selectionEnd(): number;
    set selectionEnd(v: number);
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    setSelectionRange(selectionStart: number, selectionEnd: number): void;
    blur(): void;
    select(): void;
    private _keyDown;
    private _keyDown_wrapped;
    get keyDown(): (s: IgcXInputComponent, e: IgcKeyEventArgs) => void;
    set keyDown(ev: (s: IgcXInputComponent, e: IgcKeyEventArgs) => void);
    private _keyUp;
    private _keyUp_wrapped;
    get keyUp(): (s: IgcXInputComponent, e: IgcKeyEventArgs) => void;
    set keyUp(ev: (s: IgcXInputComponent, e: IgcKeyEventArgs) => void);
    private _keyPress;
    private _keyPress_wrapped;
    get keyPress(): (s: IgcXInputComponent, e: IgcKeyEventArgs) => void;
    set keyPress(ev: (s: IgcXInputComponent, e: IgcKeyEventArgs) => void);
    private _change;
    private _change_wrapped;
    get change(): (s: IgcXInputComponent, e: IgcInputChangeEventArgs) => void;
    set change(ev: (s: IgcXInputComponent, e: IgcInputChangeEventArgs) => void);
    private _changing;
    private _changing_wrapped;
    get changing(): (s: IgcXInputComponent, e: IgcInputChangeEventArgs) => void;
    set changing(ev: (s: IgcXInputComponent, e: IgcInputChangeEventArgs) => void);
    private _compositionEnd;
    private _compositionEnd_wrapped;
    get compositionEnd(): (s: IgcXInputComponent, e: IgcInputChangeEventArgs) => void;
    set compositionEnd(ev: (s: IgcXInputComponent, e: IgcInputChangeEventArgs) => void);
}
